function GuildInfo()

local array = {}

	local g = Guild.Get(this)

	if (g ~= nil) then
		array=g.Members
	end

	local newWindow = DynamicWindow("GuildWindow","Guild Roster",600,440)

	local y = 10
	local itemsPerPage = 10
	local startIndex = (objVarPage-1) * itemsPerPage
	local i = 0
	for mobileId,entry in pairs(array) do
		local mobile = GameObj(mobileId)
		if( i >= startIndex and i <= startIndex + itemsPerPage) then
			local name = entry.Name
			local color = "[-]"
			local nocolor = "[-]"


			if (mobile ~= nil) then
				color = "[00FF00]"
			end

			if( name:len() > 55 ) then
				name = name:sub(1,52).."..."
			end

			newWindow:AddLabel(20, y, color..name..nocolor)

			if (entry.LastOnline ~= nil) then

				local lastondate = os.date("*t", entry.LastOnline)

				newWindow:AddLabel(320, y, tostring(lastondate.day).."."..tostring(lastondate.month).."."..tostring(lastondate.year))
			end

			if (entry ~= nil) then
				newWindow:AddLabel(430, y, entry.AccessLevel)
			end

			if (Guild.CheckAccessLevel(this, "Emissary") and mobile ~= this) then
				newWindow:AddButton(520, y, "Edit-"..mobileId, "<", 0, 0)
				--newWindow:AddButton(420, y, "Kick-"..entry.name, "View", 0, 0, "", "", false)
			end
			y = y + 30
			i = i + 1
		end
	end

	newWindow:AddButton(20, 380, "Invite", "Invite", 0, 0)
	if (g == nil) then
		newWindow:AddButton(100, 380, "Create", "Create", 0, 0)
	end

	if (g ~= nil) then
		if (g.Renames == nil or (g.Renames <= 3 and this == g.Leader)) then
			newWindow:AddButton(200, 380, "Rename", "Rename", 0, 0)
		end
	end

	newWindow:AddButton(300, 380, "Refresh", "Refresh", 0, 0)
	newWindow:AddButton(480, 380, "Leave", "Leave", 0, 0)

	--window:AddButton(285,530,"Increase","More",245,0)

	this:OpenDynamicWindow(newWindow)
end

function MemberInfoGump(member, g)

	if (g == nil) then
		return
	end

	DebugMessage("Info Gump: Got request for "..tostring(mobileId))

	local mi = g.Members[member]

	if ( mi == nil) then return end

	local newWindow = DynamicWindow("GuildMemberWindow","Member Info",600,440)

	newWindow:AddLabel(20, 20, "Name: "..mi.Name)
	newWindow:AddLabel(20, 50, "Access Level:" ..mi.AccessLevel)

	if (mi.LastOnline ~= nil) then

		local lastondate = os.date("*t", mi.LastOnline)
		newWindow:AddLabel(20, 80, "Last Online: "..tostring(lastondate.day).."."..tostring(lastondate.month).."."..tostring(lastondate.year))
	end

	if (mi.JoinDate ~= nil) then
		local datejoined = os.date("*t", mi.JoinDate)
		newWindow:AddLabel(20, 110, "Joined on:" ..tostring(datejoined.day).."."..tostring(datejoined.month).."."..tostring(datejoined.year))
	end

	newWindow:AddButton(20, 380, "Promote"..member, "Promote", 0, 0)
	newWindow:AddButton(100, 380, "Demote"..member, "Demote", 0, 0)
	newWindow:AddButton(500, 380, "Kick"..member, "Kick", 0, 0)


	this:OpenDynamicWindow(newWindow)

end
