-- Healer AI, which can for example cure diseases
-- Requires ai_modules.dialogue

Modules.Healer = true

Healer = {}
if AI ~= nil then
	Healer.Cost = AI.GetSetting("HealCost")
	Healer.AfterHealDialog = AI.GetSetting("AfterHealDialog")
	Healer.RefuseHealDialog = AI.GetSetting("RefuseHealDialog")
	Healer.Effect = AI.GetSetting("HealingEffect")
end
Healer.Cost = Healer.Cost or 0
Healer.AfterHealDialog = Healer.AfterHealDialog or "AfterHealing"
Healer.RefuseHealDialog = Healer.RefuseHealDialog or "RefuseHealing"

function AskForHealing(user)
	if Healer.Cost == 0 then
		PerformHealing(user)
	else
		user:RequestConsumeResource("coins", Healer.Cost, "PayForHealing", this)
	end
end
SpecialHandles.AskForHealing = AskForHealing

function PerformHealing(user)
	user:SetCurHealth(user:GetMaxHealth())
	user:SendMessage("CureAllDiseases")
	if Healer.Effect ~= nil then
		user:PlayEffect(Healer.Effect)
	end

	ShowNode(Healer.AfterHealDialog, user)
end
SpecialHandles.PerformHealing = PerformHealing

RegisterEventHandler(EventType.Message, "ConsumeResourceResponse", function (success, transaction, user)
	if transaction ~= "PayForHealing" then return end

	if success then
		PerformHealing(user)
	else
		ShowNode(Healer.RefuseHealDialog, user)
	end
end)