-- report command

-- this is based on Yorlik's "submit" command, but I am formatting the output in such a
-- way that I can easily parse the file and import its contents into a database via
-- a separate background application that monitors the report file. 

-- This format is also easily parsed by most spreadsheet applications

-- also, this has no dependency on his game time system.

-- report file will delimit field with tabs and records with a new line
-- [REALTIME] -TAB- [LOCATION] -TAB- [PLAYERCHAR] -TAB- [MESSAGE] 
report={
HandleReport = function(...)
local arg = table.pack(...)	
local text = ""
for i = 1,#arg do text = text .. tostring(arg[i]) .. " " end

	local RPTFILE = "logs/PLAYER_REPORTS.log"
	
	local realtime = DateTime.Now:ToString()
	local location = (this:GetLoc():ToString())
	
	local name = this:GetName()

	-- strip out the color codes from the name
	local strippedname = string.sub(name,9, -4)

	local report = ""..realtime.."\t"..location.."\t"..strippedname.."\t"..text.."\n\r" 
	
	local file = io.open (RPTFILE ,"a+")
   	file:write( report )
	file:close()
	this:SystemMessage("Thank you, "..name..".  Your report has been logged: \"[3030FF]"..text.."[-]\"")
end,
}

	RegisterCommand{ Command="report", AccessLevel = AccessLevel.Mortal, Func=report.HandleReport, Usage="<issue>", Desc="Report an issue to the administrators of this shard." }

