local preDefinedGoToLocations = { 
								-- Uaran
								{name="Cultist Ruins",				location=Loc(-50,0,27),		map="Uaran"},
								{name="Bridge to PvP area",			location=Loc(30,0,-17),		map="Uaran"},
								{name="Farmers House",				location=Loc(145,0,-30),	map="Uaran"},
								{name="Traveling Merchant",			location=Loc(209,0,-153),	map="Uaran"},
								{name="Ice Faction Shrine",			location=Loc(-71,0,-47),	map="Uaran"},
								{name="Earth Faction Shrine",		location=Loc(36,0,107),		map="Uaran"},
								{name="Fire Faction Shrine",		location=Loc(-136,0,107),	map="Uaran"},
								{name="Ancient Bear Cave",			location=Loc(157,0,-148),	map="Uaran"},
								{name="Easy Cultist Camp",			location=Loc(111,0,-155),	map="Uaran"},
								{name="The Weapon Master",			location=Loc(133,0,23),		map="Uaran"},
								-- Celador	
								{name="Starting Area",				location=Loc(463,0,-233),	map="Celador"},
								{name="The Dead Gate",				location=Loc(-61,0,180),	map="Celador"},
								{name="Merchant Area",				location=Loc(-5,0,-17),		map="Celador"},
								{name="Entrance to Petra",			location=Loc(180,0,34),		map="Celador"},
								{name="Eldeir Village Entrance",	location=Loc(190,0,-106),	map="Celador"},
								{name="Eldeir Village Center",		location=Loc(300,0,-137),	map="Celador"},
								{name="Cemetery Entrance",			location=Loc(173,0,-228),	map="Celador"},
								{name="Cemetery Monument",			location=Loc(228,0,-237),	map="Celador"},
								{name="Cemetery Pool of Heroes",	location=Loc(165,0,-326),	map="Celador"},
								{name="Cemetery Crypt",				location=Loc(303,0,-279), 	map="Celador"},
								{name="The Black Forest",			location=Loc(-283,0,137),	map="Celador"},
								{name="Cultist Area Entrance",		location=Loc(-186,0,-252),	map="Celador"},
								{name="Cultist Area at Pontiflex",	location=Loc(-185,0,-352),	map="Celador"},
								{name="Cultist Area Snake Pit",		location=Loc(-167,0,-441),	map="Celador"},
								{name="Cultist Area Ruins",			location=Loc(-66,0,-437), 	map="Celador"},
								}
								
local goToListPage = 1
function ShowGoToList(selectedLocation)
	local newWindow = DynamicWindow("GoToList","List of goto locations",410,735)
	if(selectedLocation == nil) then
		goToListPage = 1
	end
	local x = 20
	local y = 10
	local rowIndex = 1
	local itemsPerPage = 18
	
	local goToLocations = this:GetObjVar("StoredGoToLocations")
	if( goToLocations == nil) then
		goToLocations = preDefinedGoToLocations
		this:SetObjVar("StoredGoToLocations",goToLocations)
	end
	
	local startIndex = ((goToListPage-1) * itemsPerPage) + 1
	local commandIndex = 1
	local worldName = GetWorldName()
	
	local first = true
	
	
		
	
	for i=1,#goToLocations do
		if(goToLocations[i].map == worldName) then
			if( commandIndex >= startIndex and commandIndex < startIndex + itemsPerPage) then
				if(first == true and tonumber(selectedLocation) == nil) then
					selectedLocation = i
					first = false
				end
				tooltip = ""
				goto_name = goToLocations[i].name
				if(selectedLocation == i) then
					newWindow:AddButton(x, y, "Select:"..i,"[FF0000]"..goto_name.."[-]", 350, 0, "", "", false)
				else
					newWindow:AddButton(x, y, "Select:"..i,goto_name, 350, 0, "", "", false)
				end

				if( rowIndex == 1 ) then
					x = 20
					y = y + 30
					rowIndex = 1
				else
					x = x + 200
					rowIndex = 1
				end
			end
			commandIndex = commandIndex + 1
		end
	end
	newWindow:AddButton(40, 580, "GoTo:"..selectedLocation, "Go To", 100, 0, "Teleport to the selected location.", "", false)
	newWindow:AddButton(145, 580,"SetGoToName:"..selectedLocation,"Set Name", 100, 0, "", "", false)
	newWindow:AddButton(250, 580,"DeleteGoToLocation:"..selectedLocation,"Delete", 100, 0, "", "", false)
	newWindow:AddButton(40,630,"RevertToDefaults","Revert to defaults", 150, 0, "", "", false)
	newWindow:AddButton(195, 630, "GoToSave", "Save a Location", 150, 0, "", "", false)

	
	if( goToListPage > 1 ) then
		newWindow:AddButton(80, 680, "GoToPrev", "Previous", 100, 0, "", "", false)
	end
	if( goToListPage <= (commandIndex-1) / itemsPerPage) then
		newWindow:AddButton(210, 680, "GoToNext", "Next", 100, 0, "", "", false)
	end
	this:OpenDynamicWindow(newWindow)
end

RegisterEventHandler(EventType.DynamicWindowResponse,"GoToList",
	function (user,command)
		if(command ~= nil) then
			action,position  = string.match(command, "(%a+):(.+)")
			if(action== "GoTo") then
				this:SetWorldPosition(this:GetObjVar("StoredGoToLocations")[tonumber(position)].location)
			elseif(action == "Select") then
				ShowGoToList(tonumber(position))
			elseif(action == "SetGoToName") then
				this:SendClientMessage("EnterChat","/setgotoname".." "..position.." ")
			elseif(action == "DeleteGoToLocation") then
				if tonumber(position) ~= nil then
					local SavedGoToLocations = this:GetObjVar("StoredGoToLocations")
					table.remove(SavedGoToLocations,position)
					this:SetObjVar("StoredGoToLocations",SavedGoToLocations)
					ShowGoToList("ignore")
				else
					ShowGoToList("ignore")
				end
			else
				action = string.match(command, "(%a+)")
				if(action == "GoToSave") then
					this:RequestClientTargetLoc(this,"saveGoToLocation")
				elseif(action == "RevertToDefaults") then
					this:SetObjVar("StoredGoToLocations",preDefinedGoToLocations)
					ShowGoToList(nil)
				elseif(action == "GoToNext") then
					goToListPage = goToListPage + 1
					ShowGoToList("ignore")
				elseif( action == "GoToPrev") then
					goToListPage = goToListPage - 1
					ShowGoToList("ignore")
				end
			end
		end	
	end)

RegisterEventHandler(EventType.ClientTargetLocResponse, "saveGoToLocation",
	function(success,targetLoc)
		SavedGoToLocations = this:GetObjVar("StoredGoToLocations")
		if(SavedGoToLocations == nil) then
			SavedGoToLocations = preDefinedGoToLocations
		end
		table.insert(SavedGoToLocations, {name="Change me",location=targetLoc,map=GetWorldName()})
		this:SetObjVar("StoredGoToLocations",SavedGoToLocations)
		ShowGoToList(#SavedGoToLocations)
	end
)
	
ModedCommandFuncs= 
{
	GotoUI = function()	
		ShowGoToList(nil)
	end,

	SetGoToName = function(...)
		local args = table.pack(...)
		if( #args < 1) then
			return
		end
		local position = tonumber(args[1])
		if (position == nil) then
			return
		end
		local newName = ''
		if( #args == 2) then
			newName = args[2]
		else
			for i=2,#args do
				newName = newName..args[i].." "
			end
		end
		local SavedGoToLocations = this:GetObjVar("StoredGoToLocations")
		if( SavedGoToLocations == nil) then
			SavedGoToLocations = preDefinedGoToLocations
		end
		SavedGoToLocations[position].name=newName
		this:SetObjVar("StoredGoToLocations",SavedGoToLocations)
		ShowGoToList(position)
	end,
}
RegisterCommand{ Command="setgotoname", AccessLevel = AccessLevel.Immortal, Func=ModedCommandFuncs.SetGoToName, Usage="<number> <string>", Desc="Change the description of a specific saved location"}
RegisterCommand{ Command="gotolocation2", AccessLevel = AccessLevel.Immortal, Func=ModedCommandFuncs.GotoUI, Desc="Go to a location on the map", Aliases={"goto2"}}