-- cmd_SetClass.lua
--require 'incl_humanloot'

-- SetStartingStats(statTable,quiet)
-- EquipMobile(equipTable,lootTables,destroyExistingItems,spawnLoot,ignoreBodyParts)
local GetAbilityTable = {
 	scavenge		= "Scavenge"		,
 	spellchamber	= "SpellChamber"	,
 	destruction		= "Destruction"		,
 	spellshield		= "Spellshield"		,
 	stasis			= "Stasis"			,
 	silence			= "Silence"			,
 	empower			= "Empower"			,
 	stunstrike		= "StunStrike"		,
 	hamstring		= "Hamstring"		,
 	cleave			= "Cleave"			,
 	shieldbash		= "ShieldBash"		,
 	heroism			= "Heroism"			,
 	vanguard		= "Vanguard"		,
 	charge			= "Charge"			,
 	dart			= "Dart"			,
 	evasion			= "Evasion"			,
 	backstab		= "Backstab"		,
 	snipe			= "Snipe"			,
 	stunshot		= "StunShot"		,
 	wound			= "Wound"			,
}

local ClassData = {
	 Tiers = {20, 40, 60, 80, 100}, 
	 
	 AbilityClasses = {
		  Scavenge = "Crafter", 
		  --
		  SpellChamber = "Sorcerer", 
		  Destruction = "Sorcerer", 
		  Spellshield = "Sorcerer", 
		  --
		  Stasis = "Fieldmage", 
		  Silence = "Fieldmage", 
		  Empower = "Fieldmage", 
		  --
		  StunStrike = "Gladiator", 
		  Hamstring = "Gladiator", 
		  Cleave = "Gladiator", 
		  --
		  ShieldBash = "Knight", 
		  Heroism = "Knight", 
		  Vanguard = "Knight", 
		  Charge = "Knight", 
		  --
		  Dart = "Rogue", 
		  Evasion = "Rogue", 
		  Backstab = "Rogue", 
		  --
		  Snipe = "Scout", 
		  StunShot = "Scout", 
		  Wound = "Scout", 
		  --
	 }, 
	 
	 Head = {
		  Cloth = {"loa_robe_apprentice_helm", "loa_robe_linen_helm", "loa_robe_plant_helm", "loa_robe_knowledge_helm", "loa_robe_ritual_helm",}, 
		  Light = {"loa_light_padded_helm", "loa_light_leather_helm", "loa_light_bone_helm", "loa_light_hardened_helm", "loa_light_dragon_helm",}, 
		  Heavy = {"loa_heavy_brigandine_helm", "loa_heavy_chain_helm", "loa_heavy_scale_helm", "loa_heavy_plate_helm", "loa_heavy_fullplate_helm",}, 
	 }, 
	 
	 Chest = {
		  Cloth = {"loa_robe_apprentice_tunic", "loa_robe_linen_tunic", "loa_robe_plant_tunic", "loa_robe_knowledge_tunic", "loa_robe_ritual_tunic",}, 
		  Light = {"loa_light_padded_chest", "loa_light_leather_chest", "loa_light_bone_chest", "loa_light_hardened_chest", "loa_light_dragon_chest",}, 
		  Heavy = {"loa_heavy_brigandine_tunic", "loa_heavy_chain_tunic", "loa_heavy_scale_tunic", "loa_heavy_plate_tunic", "loa_heavy_fullplate_tunic",}, 
	 }, 
	 
	 Legs = {
		  Cloth = {"loa_robe_apprentice_leggings", "loa_robe_linen_leggings", "loa_robe_plant_legs", "loa_robe_knowledge_leggings", "loa_robe_ritual_leggings",}, 
		  Light = {"loa_light_padded_leggings", "loa_light_leather_leggings", "loa_light_bone_leggings", "loa_light_hardened_leggings", "loa_light_dragon_leggings",}, 
		  Heavy = {"loa_heavy_brigandine_leggings", "loa_heavy_chain_leggings", "loa_heavy_scale_leggings", "loa_heavy_plate_leggings", "loa_heavy_fullplate_leggings",}, 
	 }, 
	 
	 RightHand = {
		  Slashing = {"loa_sword_trainingsword", "loa_sword_rapier", "loa_sword_broad", "loa_sword_falchion", "loa_sword_katana",}, 
		  Slashing2h = {"loa_2hsword_longaxe", "loa_2hsword_greataxe", "loa_2hsword_cleaver", "loa_2hsword_peacekeeper", "loa_2hsword_justice",}, 
		  Bashing = {"loa_mace_club", "loa_mace_mace", "loa_mace_ironhammer", "loa_mace_dwarvenmace", "loa_mace_hota",}, 
		  Bashing2h = {"loa_2hmace_quarterstaff", "loa_2hmace_sledgehammer", "loa_2hmace_greathammer", "loa_2hmace_dwarvenhammer", "loa_2hmace_destruction",}, 
		  Piercing = {"loa_dagger_letter", "loa_dagger_dagger", "loa_dagger_gouge", "loa_dagger_lich", "loa_dagger_demonfang",}, 
		  Pole = {"loa_pole_warfork", "loa_pole_gladius", "loa_pole_warspear", "loa_pole_halberd", "loa_pole_runedhalberd",}, 
		  Staff2h = {"loa_staff_staff", "loa_staff_tribal", "loa_staff_iron", "loa_staff_white", "loa_staff_magi",}, 
		  Bow = {"loa_bow_shortbow", "loa_bow_longbow", "loa_bow_eldeirbow", "loa_bow_savagebow", "loa_bow_bonebow",}, 
	 }, 
	 
	 LeftHand = {
		  Shield = {"loa_shield_buckler", "loa_shield_smallshield", "loa_shield_curvedshield", "loa_shield_dwarvenshield", "loa_shield_fortress",}, 
	 }, 
	 
	 Build = {
		  basher = {
				Equipment = {Armor = "Heavy", RightHand = {"Bashing", "Bashing2h"}, LeftHand = "Shield"}, 
				Stats = {Str = 50, Agi = 20, Con = 40, Int = 10, Wis = 20, Wil = 10}, 
				Skills = {Bashing = true, Melee = true, Healing = true, HeavyArmor = true, Blocking = true, Stonemason = true}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}, 
		  }, 
		  
		  slasher = {
				Equipment = {Armor = "Heavy", RightHand = {"Slashing", "Slashing2h"}, LeftHand = "Shield"}, 
				Stats = {Str = 50, Agi = 20, Con = 40, Int = 10, Wis = 20, Wil = 10}, 
				Skills = {Slashing = true, Melee = true, Healing = true, HeavyArmor = true, Blocking = true,}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}, 
		  }, 
		  
		  piercer = {
				Equipment = {Armor = "Heavy", RightHand = {"Piercing",}, LeftHand = "Shield"}, 
				Stats = {Str = 30, Agi = 50, Con = 30, Int = 10, Wis = 20, Wil = 10}, 
				Skills = {Piercing = true, Melee = true, Healing = true, HeavyArmor = true, Blocking = true, Hiding = true}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}, 
				
		  }, 
		  
		  lancer = {
				Equipment = {Armor = "Heavy", RightHand = {"Pole"}}, 
				Stats = {Str = 50, Agi = 20, Con = 40, Int = 10, Wis = 20, Wil = 10}, 
				Skills = {Lancing = true, Melee = true, Healing = true, HeavyArmor = true, Hiding = true}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}, 
		  }, 
		  
		  rogue = {
				Equipment = {Armor = "Light", RightHand = {"Piercing",}}, 
				Stats = {Str = 30, Agi = 50, Con = 30, Int = 10, Wis = 20, Wil = 10}, 
				Skills = {Piercing = true, Melee = true, Healing = true, LightArmor = true, Hiding = true, Stealth = true}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}, 
		  }, 
		  
		  archer = {
				Equipment = {Armor = "Light", RightHand = {"Bow",}}, 
				Stats = {Str = 30, Agi = 50, Con = 30, Int = 10, Wis = 20, Wil = 10}, 
				Skills = {Archery = true, Melee = true, Healing = true, LightArmor = true, Manifestation = true,}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20, arrow = 1000}, 
		  }, 
		  
		  archer2 = {
				Equipment = {Armor = "Light", RightHand = {"Bow",}}, 
				Stats = {Str = 40, Agi = 50, Con = 30, Int = 10, Wis = 10, Wil = 10}, 
				Skills = {Archery = true, Melee = true, Healing = true, LightArmor = true, HeavyArmor = true, Manifestation = true,}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20, arrow = 1000}, 
		  }, 
		  
		  mage = {
				Equipment = {Armor = "Cloth", RightHand = {"Staff2h",}}, 
				Stats = {Str = 10, Agi = 20, Con = 30, Int = 50, Wis = 10, Wil = 30}, 
				Skills = {Evocation = true, Manifestation = true, Channeling = true, MagicAffinity = true, Alchemy = true, Inscription = true}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20, reagent_bag = 2, spellbook_full = 1}, 
		  }, 
		  
		  tamer = {
				Equipment = {Armor = "Heavy", RightHand = {"Piercing",}}, 
				Stats = {Str = 10, Agi = 40, Con = 50, Int = 30, Wis = 10, Wil = 10}, 
				Skills = {AnimalTaming = true, AnimalLore = true, Veterinary = true, Manifestation = true, HeavyArmor = true, Piercing = true}, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}
		  }, 
		  crafter = {
				Equipment = {Armor = "Cloth", RightHand = {"Piercing",}}, 
				Stats = {Str = 50, Agi = 30, Con = 30, Int = 20, Wis = 10, Wil = 10}, 
				Skills = {Lumberjack = true, Woodsmith = true, Mining = true, Metalsmith = true, Metallurgist = true, Fabrication = true, }, 
				Backpack = {tool_hunting_knife = 1, coin_purse = 10000000, item_bread = 10, bandage = 50, gauze = 25, healing_salve = 100, tinderbox = 20}
		  }, 
	 }, 
}



function ac_commands.SetBuild(build, tier, ...)
	 -- Security Check
	 --if (not this:HasObjVar("BetaTester")) and not IsGod(this) then return end

	 -- help use
	 if not build then
		  local msg = "The following Builds are available (Tiers are 1-5):\n"
		  for build, _ in pairs(ClassData.Build) do
				msg = msg .. build .. ", "
		  end
		  local msg = msg .. "\nAvailable prestige abilities are (level 1-3):\n"
		  for ability, _ in pairs(ClassData.AbilityClasses) do
				msg = msg .. ability .. ", "
		  end
		  
		  this:SystemMessage(Arcanima.Color.Info .. msg .. "\nUsage: /sb build tier abilities\nExample: /sb Archer 4 Wound 2 StunShot 3[-]")
		  return
	 end

	 build = build:lower()
	 
	 local backpackObj = this:GetEquippedObject("Backpack")
	 local contObjects = backpackObj:GetContainedObjects()
	 for _, o in pairs(contObjects) do 
		  o:Destroy()
	 end
	 
	 -- collect prestige data
	 local prestigeSkills = table.pack(...)


	 
	 tier = tonumber(tier)
	 local mBuild = ClassData.Build[build]
	 local mLvl = ClassData.Tiers[tier]
	 
	 --set stats
	 for stat, value in pairs(mBuild.Stats) do
		  this:SetStatValue(stat, value)
		  this:SetObjVar("Attr"..stat, value)
	 end

	 -- Recalculate 
	 -- MarkDirty
	 local statsToRecalculate = {
		Accuracy				= true,
		Agility					= true,
		Attack					= true,
		AttackSpeed				= true,
		Constitution			= true,
		CritChance				= true,
		CritChanceReduction		= true,
		Defense					= true,
		Evasion					= true,
		Force					= true,
		Health					= true,
		HealthRegen				= true,
		Intelligence			= true,
		Mana					= true,
		ManaRegen				= true,
		MaxHealth				= true,
		MaxMana					= true,
		MaxStamina				= true,
		MaxVitality				= true,
		MoveSpeed				= true,
		Power					= true,
		Stamina					= true,
		StaminaRegen			= true,
		Strength				= true,
		Vitality				= true,
		VitalityRegen			= true,
		Will					= true,
		Wisdom					= true,
	 }
 
	 this:SendMessage("RecalculateStats", statsToRecalculate)
	 this:ScheduleTimerDelay(TimeSpan.FromMilliseconds(100),"DoRecalculateStats")
	 
	 -- set skills
	 this:DelObjVar("SkillDictionary")
	 this:DelObjVar("TrackedSkills")
	 
	 for skill, _ in pairs(mBuild.Skills) do
		  SetSkillLevel(this, skill .. "Skill", mLvl, false)
		  AddSkillToTracker(skill .. "Skill")
	 end
	 
	 
	 -- Equip Head
	 local mHead = this:GetEquippedObject("Head")
	 --print (mHead)
	 if mHead then mHead:Destroy() end
	 CreateEquippedObj(((ClassData["Head"])[mBuild.Equipment.Armor]) [tier], this)
	 -- Equip Chest
	 local mHead = this:GetEquippedObject("Chest")
	 --print (mHead)
	 if mHead then mHead:Destroy() end
	 CreateEquippedObj(((ClassData["Chest"])[mBuild.Equipment.Armor]) [tier], this)
	 -- Equip Legs
	 local mHead = this:GetEquippedObject("Legs")
	 --print (mHead)
	 if mHead then mHead:Destroy() end
	 CreateEquippedObj(((ClassData["Legs"])[mBuild.Equipment.Armor]) [tier], this)
	 -- Equip RightHand
	 local mWep = this:GetEquippedObject("RightHand") 
	 --print (mWep)
	 if mWep then mWep:Destroy() end
	 local mWep = ((ClassData["RightHand"])[(mBuild.Equipment.RightHand[1])]) [tier]
	 CreateEquippedObj(mWep, this)
	 -- Equip RightHand2
	 local mWep2 = mBuild.Equipment.RightHand[2]
	 if mWep2 then 
		  local mWep2 = ((ClassData["RightHand"])[mWep2])[tier] 
		  CreateObjInBackpack(this, mWep2)
	 end
	 -- Equip LeftHand
	 local mWep = this:GetEquippedObject("LeftHand") 
	 if mWep then mWep:Destroy() end
	 
	 local mWep = ((ClassData["LeftHand"])[(mBuild.Equipment.LeftHand)])
	 if mWep then 
		  mWep = mWep[tier]
		  CreateEquippedObj(mWep, this)
	 end
	 -- Equip Backpack
	 for template, count in pairs(mBuild.Backpack) do
		  CreateObjInBackpack(this, template, "SetBuildCreated" .. template)
		  RegisterSingleEventHandler(EventType.CreatedObject, "SetBuildCreated" .. template, 
				function(success, objref) 
					 if success then
					 		if(IsStackable(objref)) then
								RequestSetStack(objref,count-1)
							end
							if ( success ) then
								SetItemTooltip(objref)
							end
						  
					 end
				end)
		  end
		  
		  --------------------
		  -- prestigeSkills
		  --------------------
		  -- correct case translation / parameter sanitization
		  for i = 1, #prestigeSkills do
		  	local key = GetAbilityTable[prestigeSkills[i]:lower()]
		  	if key then 
		  		prestigeSkills[i] = key
		  	end
		  end

		  this:SetStatValue("PrestigeXP", 1000000)
		  this:DelObjVar("PrestigeAbilityLevels")
		  this:DelObjVar("PrestigeAbility1")
		  this:DelObjVar("PrestigeAbility2")
		  this:DelObjVar("PrestigeAbility3")
		  
		  local PrestigeDict = {}
		  
		  for i = 1, #prestigeSkills / 2 do
				local abiIndex = 1 + (i - 1) * 2
				local lvlIndex = 2 + (i - 1) * 2
				--print(abiIndex, lvlIndex)
				PrestigeDict[prestigeSkills[abiIndex]] = {i, tonumber(prestigeSkills[lvlIndex])}
		  end
		  
		  
		  for ability, posinfo in pairs(PrestigeDict) do
				local pos = posinfo[1]
				local level = posinfo[2]
				local prestigeClass = ClassData.AbilityClasses[ability]
				UnlockPrestigeAbility(this, prestigeClass, ability, level)
				SlotPrestigeAbility(this, prestigeClass, ability, pos)
				local abilityInfo = {Class = prestigeClass, AbilityName = ability}
				local objVarKey = "PrestigeAbility" .. tonumber(pos)
				this:SetObjVar(objVarKey, abilityInfo)
				--UpdatePrestigeAbilityAction(this,pos)
		  end
		  UpdatePrestigeAbilityAction(this, 1)
		  UpdatePrestigeAbilityAction(this, 2)
		  UpdatePrestigeAbilityAction(this, 3)
		  
		  UpdateHotbar(this)
	 end
	 
	 RegisterCommand{Command = "sb", AccessLevel = AccessLevel.Mortal, Func = ac_commands.SetBuild, Desc = "Set Build: Usage: /sb build tier"}
	 
	