-- loaded  driver in globals
-- created environment object in globals

--- SET THIS TO YOUR LIKING ------------------------------------
local LOOPS=10
----------------------------------------------------------------

------------------------- Write Performance Test --------------
DebugMessage("------------------------ Entering pgtest ---------------------")

list = {
  { name="Jose das Couves", email="jose@couves.com", },
  { name="Manoel Joaquim", email="manoel.joaquim@cafundo.com", },
  { name="Maria das Dores", email="maria@dores.com", },
}

-- connect to data source
con = glob_dbconnect()

-- reset our table
res = con:execute"DROP TABLE people"
res = assert (con:execute[[
  CREATE TABLE people(
    name  varchar(50),
    email varchar(50)
  )
]])

------------------------------------------------------------------------
--- start test ---
------------------
local tStart = DateTime.Now.Ticks
for j=1,LOOPS do

-- add a few elements

for i, p in pairs (list) do
  res = assert (con:execute(string.format([[
    INSERT INTO people
    VALUES ('%s', '%s')]], p.name, p.email)
  ))
end


------------------ END WRITE TEST ------------------------------------
end

-------------- READING TEST ------------------------------------------------------

    -- retrieve a cursor
    cur = assert (con:execute"SELECT name, email from people")
    -- print all rows, the rows will be indexed by field names
    row = cur:fetch ({}, "a")
    while row do
--      print(string.format("Name: %s, E-mail: %s", row.name, row.email))
--      -- reusing the table of results
      row = cur:fetch (row, "a")
    end


-- close everything


------------------
--- test end
------------------------------------------------------------------------

cur:close() -- should already be closed because all the result set was consumed
con:close()

local tEnd = DateTime.Now.Ticks
local tResult= TimeSpan(tEnd-tStart)

DebugMessage("-----------------------------------------------------------------------")
DebugMessage("SQL Result = "..tostring(LOOPS).." loops with 3 rows write each and 3*LOOPS read ="..tostring(tResult))
DebugMessage("-----------------------------------------------------------------------")

