
require 'incl_gametime'
----------------------------------------
--- Finding a Cron Object to subscribe
----------------------------------------
local cronObj = FindObject(SearchModule("cron"))

-- Debug message
if (cronObj==nil) then
		DebugMessage("TestClient: NO CRON OBJECT FOUND !!!!!!!!!!!!! ")
	else
		DebugMessage("TestClient: Cron object found at: "..cronObj.Id)
end


---------------------------------------------------------------------

--- Ping handlers who react to getting pinged by the various timers


---------------------------------------------------------------------
--- Response to getting pinged by the cron object with "timer01"
RegisterEventHandler(EventType.Message,"Cron" .. tostring(this.Id) .. "_timer01",
	function (Data)
		ServerBroadcast(this:GetName().." "..GetGameTimeOfDayString().." ".."(T 1): "..tostring(Data), true)
		--this:NpcSpeech("It is "..GetGameTimeOfDayString().." "..tostring(Data))
	end
	)

--- Response to getting pinged by the cron object with "timer02"
RegisterEventHandler(EventType.Message,"Cron" .. tostring(this.Id) .. "_timer02",
	function (Data)
		ServerBroadcast(this:GetName().." "..GetGameTimeOfDayString().." ".."(T 2): "..tostring(Data), true)
		--this:NpcSpeech("It is "..GetGameTimeOfDayString().." "..tostring(Data))
	end
	)

----------------------------------------------------------

-- Interactive Test Functionality

----------------------------------------------------------
RegisterEventHandler(EventType.ClientObjectCommand, "interact", 
		function(user)
		user:SystemMessage("You attempt to interact: "..tostring(user))
		local menuItems = {
		"Subscribe Timer 1",
		"Subscribe Timer 2",
		"Un-Subscribe Timer 1",
		"Un-Subscribe Timer 2",
	    "Un-Subscribe All"
		}
		user:RequestContextMenu(this,"timerclient_interact", menuItems)	
	end)

RegisterEventHandler(EventType.Message, "UseObject",
	function(user)
		user:SystemMessage("You attempt to interact: "..tostring(user))
		local menuItems = {
		"Subscribe Timer 1",
		"Subscribe Timer 2",
		"Un-Subscribe Timer 1",
		"Un-Subscribe Timer 2",
	    "Un-Subscribe All"
		}
		user:RequestContextMenu(this,"timerclient_interact", menuItems)	
	end)

RegisterEventHandler(EventType.ContextMenuResponse,"timerclient_interact", 
	function (user,menuIndex)
	    if( menuIndex == 0 ) then return end
	    if( user == nil or not(user:IsValid())) then return end
	    if( user:DistanceFrom(this) > OBJECT_INTERACTION_RANGE) then return end

	    if( menuIndex == 1 ) then
	    	local MyMessage={Id=this.Id, Interval=10, StartTime={1023, 11, 29, 00, 0}, Name="timer01", Data = "Hello friend!  I'm Little Lucy."}
	    	user:SystemMessage (this:GetName()..": Subscribing timer01 " .. tostring( cronObj:SendMessage("CronSubscribe", MyMessage)))
	    elseif( menuIndex == 2 ) then	
	    	local MyMessage={Id=this.Id, Interval=6, StartTime={1023, 11, 29, 23, 00}, Name="timer02", Data = "I like diamonds in the sky ..."}
	    	user:SystemMessage (this:GetName()..": Subscribing timer02 " .. tostring( cronObj:SendMessage("CronSubscribe", MyMessage)))
	    elseif( menuIndex == 3 ) then
	    	user:SystemMessage ("Un-Subscribing timer01 " .. tostring(cronObj:SendMessage("CronUnSubscribe", {Id=this.Id, Name="timer01"}) ))
	    elseif( menuIndex == 4 ) then
	    	user:SystemMessage ("Un-Subscribing timer02 " .. tostring(cronObj:SendMessage("CronUnSubscribe", {Id=this.Id, Name="timer02"}) ))
	    elseif( menuIndex == 5 ) then
	    	user:SystemMessage ("Un-Subscribing All" .. tostring(cronObj:SendMessage("CronRemoveObject", this.Id) ))
	    end
	end)





